Attribute VB_Name = "Module1"
Option Explicit

Global Const MODAL = 1

'Input Box constants
Global Const OK_BUTTON = 0
Global Const OK_CANCEL = 1
Global Const YES_NO = 2

'Returned Text
Global gInputBoxReturn$

' Standard Icon IDs
Public Const IDI_HAND = 32513&
Public Const IDI_QUESTION = 32514&
Public Const IDI_EXCLAMATION = 32515&
Public Const IDI_ASTERISK = 32516&

'Windows API Calls
Declare Function DrawIcon Lib "user32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal hIcon As Long) As Long
Declare Function LoadIcon Lib "user32" Alias "LoadIconA" (ByVal hInstance As Long, ByVal lpIconName As Any) As Long

Sub Main()
Dim ReturnText$
  
  MsgBox "This is a standard MsgBox", vbCritical, App.Title
  
  ReturnText$ = InputBox("This is a standard InputBox", App.Title)
  
  ReturnText$ = EnhancedInputBox(IDI_HAND, OK_CANCEL, "Please enter text here", ReturnText$)
  ReturnText$ = EnhancedInputBox(IDI_QUESTION, OK_CANCEL, "Please enter text here", ReturnText$)
  ReturnText$ = EnhancedInputBox(IDI_EXCLAMATION, OK_CANCEL, "Please enter text here", ReturnText$)
  ReturnText$ = EnhancedInputBox(IDI_ASTERISK, OK_CANCEL, "Please enter text here", ReturnText$)
  
  End
  
End Sub

Sub CenterDialogPosition(WNdName As Form)

  WNdName.Top = (Screen.Height - WNdName.Height) \ 2
  WNdName.Left = (Screen.Width - WNdName.Width) \ 2

End Sub

Function EnhancedInputBox(Icon&, Button%, Label$, Default$) As String
Dim IconhWnd%, ReturnCode%, LeftPosition%, CommandWidth%, ReturnText$
Dim TextLength%, LineLength%, LabelLines%, CommandTop%

  Load frmInputBox

  frmInputBox.Caption = App.Title
  
  'Display the InputBox icon in picScreenIcon.
  IconhWnd% = LoadIcon(0, Icon&)
  ReturnCode% = DrawIcon(frmInputBox!picScreenIcon.hDC, 0, 0, IconhWnd%)
  frmInputBox!picScreenIcon.Picture = frmInputBox!picScreenIcon.Image
  
  'Display Proper buttons
  Load frmInputBox!cmdButton(1)
  Select Case Button%
    Case OK_BUTTON
      EnhancedInputBox$ = ""
      Exit Function
    Case OK_CANCEL
      frmInputBox!cmdButton(0).Caption = "OK"
      frmInputBox!cmdButton(0).Default = True
      frmInputBox!cmdButton(1).Caption = "Cancel"
      frmInputBox!cmdButton(1).Cancel = True
    Case YES_NO
      frmInputBox!cmdButton(0).Caption = "YES"
      frmInputBox!cmdButton(0).Default = True
      frmInputBox!cmdButton(1).Caption = "NO"
      frmInputBox!cmdButton(1).Cancel = True
  End Select
  
  'Position the command button in center of the form at bottom
  CommandWidth% = frmInputBox!cmdButton(0).Width
  LeftPosition% = ((frmInputBox.ScaleWidth \ 2) - (CommandWidth% + 4))
  frmInputBox!cmdButton(0).Left = LeftPosition%
  frmInputBox!cmdButton(1).Left = LeftPosition% + CommandWidth% + 8
  frmInputBox!cmdButton(1).Visible = True

  'Check length of message and resize form and command buttons accordingly
  
  LineLength% = frmInputBox.TextWidth("mmmmmmmmmmmmmmmmmmmm")
  TextLength% = frmInputBox.TextWidth(Label$)
  If TextLength% > LineLength% Then
    LabelLines% = Int(TextLength% / LineLength%) + 1
    frmInputBox!lblInstructions.Height = (frmInputBox.TextHeight("X") * LabelLines%)
    frmInputBox!lblInstructions.Top = frmInputBox!picScreenIcon.Top + ((frmInputBox!picScreenIcon.Height - frmInputBox!lblInstructions.Height) / 2)
    frmInputBox!txtInputText.Top = frmInputBox!lblInstructions.Top + frmInputBox!lblInstructions.Height + 8
    CommandTop% = frmInputBox!txtInputText.Top + frmInputBox!txtInputText.Height + 16
    frmInputBox!cmdButton(0).Top = CommandTop%
    frmInputBox!cmdButton(1).Top = CommandTop%
    frmInputBox.Height = Screen.TwipsPerPixelY * (CommandTop% + frmInputBox!cmdButton(0).Height + 40)
  End If
  
  'Show Label
  frmInputBox!lblInstructions.Caption = Label$
  
  'Show Text box if indicated
  frmInputBox!txtInputText.Text = Default$
  
  frmInputBox.Show MODAL
  Unload frmInputBox
  
  'Sets the return text
  ReturnText$ = gInputBoxReturn$
  Select Case ReturnText$
    Case "CANCEL"
      ReturnText$ = ""
    Case "NO"
      ReturnText$ = ""
    Case Else
      EnhancedInputBox$ = ReturnText$
  End Select

End Function
